package com.example.cookbook.repository;

import com.example.cookbook.dbConfig.DB;
import com.example.cookbook.model.Recept;
import com.example.cookbook.model.Slika;
import org.springframework.stereotype.Repository;

import java.nio.charset.StandardCharsets;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

@Repository
public class SlikiZaReceptRepository {

    public List<Slika> findAllForRecipe(Long recId) throws SQLException {
        Connection connection = DB.getConnection();

        String query = "select * from sliki s where s.rec_id = ? order by s.reden_broj asc";
        PreparedStatement prepStm = connection.prepareStatement(query);
        prepStm.setLong(1, recId);

        ResultSet result = prepStm.executeQuery();
        List<Slika> sliki = new ArrayList<>();

        while (result.next()){
            Slika slika = new Slika();
            slika.setRecId(result.getLong("rec_id"));
            slika.setRedenBroj(result.getInt("reden_broj"));
            slika.setPic(new String(result.getBytes("slika"), StandardCharsets.UTF_8));
            sliki.add(slika);
        }

        result.close();
        prepStm.close();
        DB.closeConnection();

        return sliki;
    }
}
