package com.example.cookbook.repository;


import com.example.cookbook.dbConfig.DB;
import com.example.cookbook.model.Slika;
import com.example.cookbook.model.Sostojka;
import org.springframework.stereotype.Repository;

import java.nio.charset.StandardCharsets;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

@Repository
public class SostojkiRespository {


    public List<Sostojka> findAllByRId(Long rId) throws SQLException {
        Connection connection = DB.getConnection();

        String query = "select s.s_id, s_naziv\n" +
                "from sodrzi\n" +
                "    left join sostojki s on\n" +
                "        sodrzi.s_id = s.s_id\n" +
                "where rec_id = ?";

        PreparedStatement prepStm = connection.prepareStatement(query);
        prepStm.setLong(1, rId);

        ResultSet result = prepStm.executeQuery();
        List<Sostojka> sostojki = new ArrayList<>();

        while (result.next()){
            Sostojka sostojka = new Sostojka();
            sostojka.setsId(result.getLong("s_id"));
            sostojka.setsNaziv(result.getString("s_naziv"));
            sostojki.add(sostojka);
        }

        result.close();
        prepStm.close();
        DB.closeConnection();

        return sostojki;
    }
}
