package com.example.cookbook.service.impl;

import com.example.cookbook.model.Recept;
import com.example.cookbook.model.exception.ReceptNeEPronajdenException;
import com.example.cookbook.repository.ReceptRepository;
import com.example.cookbook.service.ReceptService;
import org.springframework.stereotype.Service;

import java.sql.SQLException;
import java.util.List;
import java.util.Optional;

@Service
public class ReceptServiceImpl implements ReceptService {

    private final ReceptRepository receptRepository;

    public ReceptServiceImpl(ReceptRepository receptRepository) {
        this.receptRepository = receptRepository;
    }

    @Override
    public List<Recept> listAll() throws SQLException {
        return receptRepository.findAll();
    }

    @Override
    public Recept findById(Long id) throws SQLException {
        Recept recept;

        recept = receptRepository.findById(id).orElseThrow(ReceptNeEPronajdenException::new);

        return recept;
    }
}
